<?php

    namespace Keybert;

    use ncc\Runtime;

    class Program
    {
        /**
         * Main entry point for the CLI
         *
         * @param array $args
         * @return void
         */
        public static function main(array $args=[]): void
        {
            if(getenv('KEYBERT_PORT') === false)
            {
                $port = $args['port'] ?? $args['p'] ?? null;
            }
            else
            {
                $port = getenv('KEYBERT_PORT');
            }

            if(getenv('KEYBERT_PRELOAD') === false)
            {
                $preload = $args['preload'] ?? $args['l'] ?? null;
            }
            else
            {
                $preload = getenv('KEYBERT_PRELOAD');
            }

            $keybert = new Keybert($preload, null, $port);
            $keybert->run();
        }

        /**
         * Displays the help message
         *
         * @return void
         */
        public static function help(): void
        {
            print('Keybert v' . Runtime::getConstant('net.nosial.federationlib', 'version') . PHP_EOL . PHP_EOL);

            print('Usage: Keybert [options]' . PHP_EOL);
            print('Options:' . PHP_EOL);
            print('  --port|-p - The port to listen on' . PHP_EOL);
            print('  --preload|-l - Optional. Models to preload, seperated by commas' . PHP_EOL);
            print(PHP_EOL);
            print('Environment Variables:' . PHP_EOL);
            print('  KEYBERT_PORT - The port to listen on' . PHP_EOL);
            print('  KEYBERT_PRELOAD - Optional. Models to preload, seperated by commas' . PHP_EOL);

            exit(0);
        }
    }